// wmf.cpp define metafile functions
// doug overmyer 6/10/93



#include  	"stdafx.h"
#include  	"wmf.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif   


                                              
///////////////////////////  LoadPCXFile()
HGLOBAL LoadAldusFile(LPSTR fname)
{
	HGLOBAL						hMFP;        //handle to metafile pict    
	METAFILEPICT far* pMFP;
	ALDUSHEADER				aldusheader;
	METAHEADER				metaheader;         
	DWORD							actual;
	HGLOBAL						hMFB;  			//(handle to metafile bits) 
	LPSTR							pMFB;       // pointer to metafile bits)

	CFile       f;
	CFileException fe; 
	DWORD				fsize;   
	CString			filename(fname);
	
	if ( !f.Open(filename, CFile::modeRead | CFile::shareDenyWrite, &fe)  )
		return 0;

	fsize=f.GetLength();
	f.Seek(0,CFile::begin);
	actual=f.Read(&aldusheader,sizeof(aldusheader));   
	actual=f.Read(&metaheader,sizeof(metaheader)); 
	
	hMFB=(HGLOBAL)::GlobalAlloc(GHND,DWORD(metaheader.mtSize * 2));
	if (!hMFB) return 0;
	
	pMFB =(LPSTR)::GlobalLock(hMFB);
	
	actual=f.Seek(sizeof(ALDUSHEADER),CFile::begin); //position to start of metaheader/bits
	actual=f.ReadHuge(pMFB,DWORD(metaheader.mtSize * 2)); 
	
	::GlobalUnlock(hMFB);
	
	hMFP= (HGLOBAL)::GlobalAlloc(GHND, sizeof(METAFILEPICT));
  pMFP = (METAFILEPICT far *)::GlobalLock(hMFP);
  pMFP->hMF = ::SetMetaFileBits(hMFB);   
  pMFP->xExt = abs(aldusheader.BBox.right - aldusheader.BBox.left);
  pMFP->yExt = abs(aldusheader.BBox.bottom - aldusheader.BBox.top); 
  pMFP->mm = MM_ANISOTROPIC;
  GlobalUnlock(hMFP);
		
	return hMFP;
}	            

void DelPICT(HGLOBAL H)
{
	METAFILEPICT far * pMFP;
	
	if (!H) return;	
	pMFP = (METAFILEPICT far*)::GlobalLock(H);
	if (!pMFP) return;	
	::DeleteMetaFile(pMFP->hMF);
	::GlobalUnlock(H);
	::GlobalFree(H);
}       

void GetPICTScale(HGLOBAL H,CDC* pDC, CWnd* pWnd, LONG& X, LONG& Y)
{
	int 							oldMode;
	PMETAFILEPICT     pMFP;
	CPoint 						xP(0,0),yP(0,0);
	CRect							cR;
  
  pWnd->GetClientRect(&cR);
  X = Y = 0;
  if (!H) return;
  
	pMFP = (PMETAFILEPICT)::GlobalLock(H);
	if (!pMFP) return;
	
	if( (pMFP->mm == MM_ISOTROPIC) || (pMFP->mm == MM_ANISOTROPIC) )
		oldMode = pDC->SetMapMode(MM_HIMETRIC);
	else
		oldMode = pDC->SetMapMode(pMFP->mm);      
  xP.x = pMFP->xExt;
  yP.y = pMFP->yExt;  
  pDC->SetViewportOrg(0,0);
  pDC->LPtoDP(&xP);pDC->LPtoDP(&yP); //get nominal size of image  
  pDC->SetMapMode(oldMode);   
  
  ::GlobalUnlock(H);
  
  X=abs(xP.x); Y=abs(yP.y);
  if ( (X==0) || (Y==0) ) 
  	{
  	X = cR.right;
  	Y = cR.bottom;
  	}
  
  return;    
}

void RenderPICT(HGLOBAL H, CDC* pDC, CWnd* pWnd, CRect sR)
{
	int 							oldMode;
	PMETAFILEPICT     pMFP;
	int 							X,Y,maxXY;
	
	if (!H) return;
	
	X= sR.right;
	Y= sR.bottom;
	maxXY=max(X,Y);
	pMFP = (PMETAFILEPICT)::GlobalLock(H); 
	oldMode = pDC->SetMapMode(pMFP->mm);
  pDC->SetViewportOrg(0,0);
  pDC->SetViewportExt(X,Y);
  pDC->PlayMetaFile(pMFP->hMF);
  ::GlobalUnlock(H);
  pDC->SetMapMode(oldMode);
}     

void PICTtoDDB(HGLOBAL H, CDC* pDC, CWnd* pWnd, CRect sR,CBitmap* pBmp)
{
 LONG  						X,Y,maxXY;
 CDC							memDC;
 CBitmap*	        poldBmp;  
 CRect						rC;    
 CBrush						whiteBr;
 
 	if (!H) return;
 	
 	GetPICTScale(H,pDC,pWnd,X,Y);
 	maxXY=max(X,Y);
 	if (sR.right)
 		rC.SetRect( 0,0,sR.right*(int)(X/maxXY),sR.bottom*(int)(Y/maxXY) );
 	else
 		rC.SetRect(0,0,(int)X,(int)Y);
 		
 	memDC.CreateCompatibleDC(pDC);   
 	
 	pBmp->CreateCompatibleBitmap(pDC,rC.right, rC.bottom);  
 	poldBmp=memDC.SelectObject(pBmp); 
 	whiteBr.CreateStockObject(WHITE_BRUSH);
 	memDC.FillRect(rC,&whiteBr);
  RenderPICT(H,&memDC,pWnd,rC);
  memDC.SelectObject(poldBmp);
 }  
 
 HGLOBAL CopyPICT(HGLOBAL H)
 {
	PMETAFILEPICT     pMFP=NULL,pMFP1=NULL;
	HGLOBAL						hMFP=0;
	
	pMFP1 = (PMETAFILEPICT)::GlobalLock(H);
	if (!pMFP1) return 0;
	hMFP=(HGLOBAL)::GlobalAlloc(GHND,sizeof(METAFILEPICT));
	pMFP=(PMETAFILEPICT)::GlobalLock(hMFP);
	*pMFP=*pMFP1;
	pMFP->hMF = CopyMetaFile(pMFP->hMF,NULL);
	::GlobalUnlock(H);
	::GlobalUnlock(hMFP);
	return hMFP;
 }